/[gentoo-x86]/eclass/haskell-cabal.eclass
Gentoo

Diff of /eclass/haskell-cabal.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.13 Revision 1.15
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2006 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/haskell-cabal.eclass,v 1.13 2007/08/05 18:49:58 kolmodin Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/haskell-cabal.eclass,v 1.15 2009/07/27 19:03:20 kolmodin Exp $
4# 4#
5# Original authors: Andres Loeh <kosmikus@gentoo.org> 5# Original authors: Andres Loeh <kosmikus@gentoo.org>
6# Duncan Coutts <dcoutts@gentoo.org> 6# Duncan Coutts <dcoutts@gentoo.org>
7# Maintained by: Haskell herd <haskell@gentoo.org> 7# Maintained by: Haskell herd <haskell@gentoo.org>
8# 8#
59done 59done
60 60
61if [[ -n "${CABAL_USE_HADDOCK}" ]]; then 61if [[ -n "${CABAL_USE_HADDOCK}" ]]; then
62 IUSE="${IUSE} doc" 62 IUSE="${IUSE} doc"
63 DEPEND="${DEPEND} doc? ( dev-haskell/haddock )" 63 DEPEND="${DEPEND} doc? ( dev-haskell/haddock )"
64 cabalconf="${cabalconf} --with-haddock=/usr/bin/haddock"
65fi 64fi
66 65
67if [[ -n "${CABAL_USE_ALEX}" ]]; then 66if [[ -n "${CABAL_USE_ALEX}" ]]; then
68 DEPEND="${DEPEND} dev-haskell/alex" 67 DEPEND="${DEPEND} dev-haskell/alex"
69 cabalconf="${cabalconf} --with-alex=/usr/bin/alex" 68 cabalconf="${cabalconf} --with-alex=/usr/bin/alex"
88 IUSE="${IUSE} profile" 87 IUSE="${IUSE} profile"
89fi 88fi
90 89
91# We always use a standalone version of Cabal, rather than the one that comes 90# We always use a standalone version of Cabal, rather than the one that comes
92# with GHC. But of course we can't depend on cabal when building cabal itself. 91# with GHC. But of course we can't depend on cabal when building cabal itself.
92if [[ -z ${CABAL_MIN_VERSION} ]]; then
93CABAL_MIN_VERSION=1.1.4 93 CABAL_MIN_VERSION=1.1.4
94fi
94if [[ -z "${CABAL_BOOTSTRAP}" ]]; then 95if [[ -z "${CABAL_BOOTSTRAP}" ]]; then
95 DEPEND="${DEPEND} >=dev-haskell/cabal-${CABAL_MIN_VERSION}" 96 DEPEND="${DEPEND} >=dev-haskell/cabal-${CABAL_MIN_VERSION}"
96fi 97fi
97 98
98# Libraries require GHC to be installed. 99# Libraries require GHC to be installed.
99if [[ -n "${CABAL_HAS_LIBRARIES}" ]]; then 100if [[ -n "${CABAL_HAS_LIBRARIES}" ]]; then
100 RDEPEND="${RDEPEND} dev-lang/ghc" 101 RDEPEND="${RDEPEND} dev-lang/ghc"
101fi 102fi
102 103
104# returns the version of cabal currently in use
105_CABAL_VERSION_CACHE=""
106cabal-version() {
107 if [[ -z "${_CABAL_VERSION_CACHE}" ]]; then
108 if [[ "${CABAL_BOOTSTRAP}" ]]; then
109 # We're bootstrapping cabal, so the cabal version is the version
110 # of this package itself.
111 _CABAL_VERSION_CACHE="${PV}"
112 else
113 # We ask portage, not ghc, so that we only pick up
114 # portage-installed cabal versions.
115 _CABAL_VERSION_CACHE="$(ghc-extractportageversion dev-haskell/cabal)"
116 fi
117 fi
118 echo "${_CABAL_VERSION_CACHE}"
119}
120
103cabal-bootstrap() { 121cabal-bootstrap() {
104 local setupmodule 122 local setupmodule
105 local cabalversion 123 local cabalpackage
106 if [[ -f "${S}/Setup.lhs" ]]; then 124 if [[ -f "${S}/Setup.lhs" ]]; then
107 setupmodule="${S}/Setup.lhs" 125 setupmodule="${S}/Setup.lhs"
108 else 126 else
109 if [[ -f "${S}/Setup.hs" ]]; then 127 if [[ -f "${S}/Setup.hs" ]]; then
110 setupmodule="${S}/Setup.hs" 128 setupmodule="${S}/Setup.hs"
113 fi 131 fi
114 fi 132 fi
115 133
116 # We build the setup program using the latest version of 134 # We build the setup program using the latest version of
117 # cabal that we have installed 135 # cabal that we have installed
118 cabalversion=$(ghc-bestcabalversion) 136 if version_is_at_least "6.4" "$(ghc-version)"; then
137 cabalpackage=Cabal-$(cabal-version)
138 else
139 # older ghc's don't support package versioning
140 cabalpackage=Cabal
141 fi
119 einfo "Using ${cabalversion}." 142 einfo "Using cabal-$(cabal-version)."
120 $(ghc-getghc) -package "${cabalversion}" --make "${setupmodule}" -o setup \ 143 $(ghc-getghc) -package "${cabalpackage}" --make "${setupmodule}" -o setup \
121 || die "compiling ${setupmodule} failed" 144 || die "compiling ${setupmodule} failed"
145}
146
147cabal-mksetup() {
148 local setupdir
149
150 if [[ -n $1 ]]; then
151 setupdir=$1
152 else
153 setupdir=${S}
154 fi
155
156 rm -f "${setupdir}"/Setup.{lhs,hs}
157
158 echo 'import Distribution.Simple; main = defaultMainWithHooks defaultUserHooks' \
159 > $setupdir/Setup.hs
122} 160}
123 161
124cabal-haddock() { 162cabal-haddock() {
125 ./setup haddock || die "setup haddock failed" 163 ./setup haddock || die "setup haddock failed"
126} 164}
127 165
128cabal-configure() { 166cabal-configure() {
167 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then
168 cabalconf="${cabalconf} --with-haddock=/usr/bin/haddock"
169 fi
129 if [[ -n "${CABAL_USE_PROFILE}" ]] && use profile; then 170 if [[ -n "${CABAL_USE_PROFILE}" ]] && use profile; then
130 cabalconf="${cabalconf} --enable-library-profiling" 171 cabalconf="${cabalconf} --enable-library-profiling"
131 fi 172 fi
132 # Building GHCi libs on ppc64 causes "TOC overflow". 173 # Building GHCi libs on ppc64 causes "TOC overflow".
133 if use ppc64; then 174 if use ppc64; then
134 cabalconf="${cabalconf} --disable-library-for-ghci" 175 cabalconf="${cabalconf} --disable-library-for-ghci"
135 fi 176 fi
136 177
178 if version_is_at_least "1.2.0" "$(cabal-version)"; then
179 cabalconf="${cabalconf} --docdir=/usr/share/doc/${PF}"
180 # As of Cabal 1.2, configure is quite quiet. For diagnostic purposes
181 # it's better if the configure chatter is in the build logs:
182 cabalconf="${cabalconf} --verbose"
183 fi
137 # Note: with Cabal-1.1.6.x we still do not have enough control 184 # Note: with Cabal-1.1.6.x we do not have enough control
138 # to put the docs into the right place. They're currently going 185 # to put the docs into the right place. They're currently going
139 # into /usr/share/${P}/ghc-x.y/doc/ 186 # into /usr/share/${P}/ghc-x.y/doc/
140 # rather than /usr/share/doc/${PF}/ 187 # rather than /usr/share/doc/${PF}/
141 # Because we can only set the datadir, not the docdir. 188 # Because we can only set the datadir, not the docdir.
142 189
153 ${CABAL_CONFIGURE_FLAGS} \ 200 ${CABAL_CONFIGURE_FLAGS} \
154 "$@" || die "setup configure failed" 201 "$@" || die "setup configure failed"
155} 202}
156 203
157cabal-build() { 204cabal-build() {
205 unset LANG LC_ALL LC_MESSAGES
158 ./setup build \ 206 ./setup build \
159 || die "setup build failed" 207 || die "setup build failed"
160} 208}
161 209
162cabal-copy() { 210cabal-copy() {
183 # register that ourselves (if it exists). 231 # register that ourselves (if it exists).
184 local result 232 local result
185 local err 233 local err
186 234
187 if [[ -n ${CABAL_HAS_LIBRARIES} ]]; then 235 if [[ -n ${CABAL_HAS_LIBRARIES} ]]; then
188 sed -i "s|$(ghc-getghcpkg)|$(type -P true)|" .setup-config 236 if version_is_at_least "1.2.0" "$(cabal-version)"; then
189 ./setup register || die "setup register failed" 237 # Newer cabal can generate a package conf for us:
190 if [[ -f .installed-pkg-config ]]; then 238 ./setup register --gen-pkg-config="${T}/${P}.conf"
191 ghc-setup-pkg .installed-pkg-config 239 ghc-setup-pkg "${T}/${P}.conf"
192 ghc-install-pkg 240 ghc-install-pkg
193 else 241 else
242 # With older cabal we have to hack it by replacing its ghc-pkg
243 # with true and then just picking up the .installed-pkg-config
244 # file and registering that ourselves (if it exists).
245 sed -i "s|$(ghc-getghcpkg)|$(type -P true)|" .setup-config
246 ./setup register || die "setup register failed"
247 if [[ -f .installed-pkg-config ]]; then
248 ghc-setup-pkg .installed-pkg-config
249 ghc-install-pkg
250 else
194 die "setup register has not generated a package configuration file" 251 die "setup register has not generated a package configuration file"
252 fi
195 fi 253 fi
196 fi 254 fi
197} 255}
198 256
199# Some cabal libs are bundled along with some versions of ghc 257# Some cabal libs are bundled along with some versions of ghc
223 fi 281 fi
224 if [[ -z "${CABAL_HAS_BINARIES}" ]] && [[ -z "${CABAL_HAS_LIBRARIES}" ]]; then 282 if [[ -z "${CABAL_HAS_BINARIES}" ]] && [[ -z "${CABAL_HAS_LIBRARIES}" ]]; then
225 eerror "QA: Neither bin nor lib are in CABAL_FEATURES." 283 eerror "QA: Neither bin nor lib are in CABAL_FEATURES."
226 fi 284 fi
227 if [[ -n "${CABAL_UNKNOWN}" ]]; then 285 if [[ -n "${CABAL_UNKNOWN}" ]]; then
228 ewarn "Unknown entry in CABAL_FEATURES: ${CABAL_UNKNONW}" 286 ewarn "Unknown entry in CABAL_FEATURES: ${CABAL_UNKNOWN}"
229 fi 287 fi
230 if cabal-is-dummy-lib; then 288 if cabal-is-dummy-lib; then
231 einfo "${P} is included in ghc-${CABAL_CORE_LIB_GHC_PV}, nothing to install." 289 einfo "${P} is included in ghc-${CABAL_CORE_LIB_GHC_PV}, nothing to install."
232 fi 290 fi
233} 291}
257 else 315 else
258 cabal-copy 316 cabal-copy
259 cabal-pkg 317 cabal-pkg
260 318
261 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then 319 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then
262 local cabalversion=$(ghc-extractportageversion dev-haskell/cabal)
263 if ! version_is_at_least "1.1.6" "${cabalversion}"; then 320 if ! version_is_at_least "1.1.6" "$(cabal-version)"; then
264 dohtml -r dist/doc/html/* 321 dohtml -r dist/doc/html/*
265 fi 322 fi
266 fi 323 fi
267 fi 324 fi
268} 325}

Legend:
Removed from v.1.13  
changed lines
  Added in v.1.15

  ViewVC Help
Powered by ViewVC 1.1.20